/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim:set ts=2 sw=2 sts=2 et cindent tw=79 ft=idl: */
/*
 * Copyright (C) 2007,2008 Sergey Yanovich <ynvich@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "nsISupports.idl"

/*
 * The aaIHandler interface
 * @status UNSTABLE
 */

interface aaIListNode;
interface aaIEntity;
interface aaIResource;
interface aaIMoney;
interface aaIAsset;
interface aaIFlow;
interface aaIRule;
interface aaIState;
interface aaIFact;
interface aaIEvent;
interface aaIQuote;
interface aaITransaction;

[scriptable, uuid(99767064-5925-462c-b1c7-172641f4c162)]
interface aaIHandler : nsISupports
{ 
  void handleNode(in aaIListNode aNode);
  void handleEntity(in aaIEntity entity);
  void handleResource(in aaIResource resource);
  void handleAsset(in aaIAsset asset);
  void handleMoney(in aaIMoney money);
  void handleFlow(in aaIFlow flow);
  void handleRule(in aaIRule aRule);
  void handleState(in aaIState state);
  void handleFact(in aaIFact fact);
  void handleEvent(in aaIEvent event);
  void handleQuote(in aaIQuote quote);
  void handleTransaction(in aaITransaction transaction);
};

